﻿using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework.Graphics;

namespace LightningCommand
{
    public class ArtManager
    {
        public Dictionary<string, Texture2D> textures;

        public ArtManager()
        {
            textures = new Dictionary<string, Texture2D>();
        }


        public void Initialize(Microsoft.Xna.Framework.Content.ContentManager content, string[] textureFileNames)
        {
            foreach(string fileName in textureFileNames)
            {
                string filePath = "Textures/" + fileName;
                textures.Add(fileName, content.Load<Texture2D>(filePath));
            }
        }

        public void Destroy()
        {
            foreach(var texture in textures)
            {
                texture.Value.Dispose();
            }
        }
    }
}
