﻿using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace LightningCommand.Graphics.Particle
{
    public class Particle
    {
        public Texture2D Texture { get; set; }
        public Vector2 Position { get; set; }
        public Vector2 Velocity { get; set; }
        public float Angle { get; set; }
        public float AngularVelocity { get; set; }
        public Color Tint { get; set; }
        public float Size { get; set; }
        public int Duration { get; set; }

        public Particle(Texture2D texture, Vector2 position, Vector2 velocity, float angle, float angularVelocity,
            Color tint, float size, int duration)
        {
            Texture = texture;
            Position = position;
            Velocity = velocity;
            Angle = angle;
            AngularVelocity = angularVelocity;
            Tint = tint;
            Size = size;
            Duration = duration;
        }

        public void Update(int updateSpeed)
        {
            Duration -= updateSpeed;
            Position += Velocity;
            Angle += AngularVelocity;
        }

        public void Draw(ref SpriteBatch spriteBatch)
        {
            Rectangle srcRect = new Rectangle(0, 0, Texture.Width, Texture.Height);
            Vector2 origin = new Vector2(Texture.Width / 2, Texture.Height / 2);

            spriteBatch.Draw(Texture, Position, srcRect, Tint, Angle, origin, Size, SpriteEffects.None, 0f);
        }
    }
}