﻿using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace LightningCommand.Graphics
{
    class WeaponFlash
    {
        public Vector2 Position { get; set; }
        public float Scale { get; set; }
        public bool IsActive { get; set; }
        public bool IsCharging { get; set; }

        private float timer;
        private Color color;

        public WeaponFlash(Vector2 position)
        {
            Position = position;
            Scale = 0.01f;
            IsActive = true;
            IsCharging = true;
            timer = 4; // seconds to live
            color = new Color(1.0f, 1.0f, 1.0f);
        }

        public void Update(float deltaTime)
        {
            if (IsCharging)
            {
                Scale += deltaTime;
                if (Scale > 2.0f)
                    Scale = 2.0f;
            }
            else
                timer -= deltaTime;
            
            if(timer < 0f)
            {
                IsActive = false;
            }

            float colorValue = timer / 4.0f;
            color = new Color(colorValue, colorValue, colorValue);

        }

        public void Draw(SpriteBatch spriteBatch, ref ArtManager art)
        {
            Vector2 offset = new Vector2(art.textures["explosion"].Width / 2f, art.textures["explosion"].Height / 2f);
            Rectangle srcRect = new Rectangle(0, 0, art.textures["explosion"].Width, art.textures["explosion"].Height);
            spriteBatch.Draw(art.textures["explosion"], Position, srcRect, color, 0f, offset, Scale, SpriteEffects.None, 0f);
        }

    }
}
