﻿using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;

namespace LightningCommand
{
    class Input
    {
        public bool escape;
        public bool select;
        public ButtonState leftClick;
        public ButtonState rightClick;
        public bool upArrow;
        public bool downArrow;
        public bool rightArrow;
        public bool leftArrow;

        public Vector2 cursorPos;
        public Vector2 previousCursorPos;
        
        //bool isMouseEnabled;
        //bool isGamePadEnabled;

        KeyboardState currentKeyboardState;
        KeyboardState previousKeyboardState;

        GamePadState currentGamePadState;
        GamePadState previousGamePadState;

        MouseState currentMouseState;
        MouseState previousMouseState;

        public Input()
        {
        //    isMouseEnabled = false;
        //    isGamePadEnabled = false;
            escape = false;
            select = false;
            upArrow = false;
            downArrow = false;
            leftArrow = false;
            rightArrow = false;
            cursorPos = Vector2.Zero;

        }

        public void Update(float deltaTime)
        {
            escape = false;
            select = false;
            upArrow = false;
            downArrow = false;
            leftArrow = false;
            rightArrow = false;

            // update keyboard
            if (currentKeyboardState.IsKeyDown(Keys.Escape)) escape = true;
            if (currentKeyboardState.IsKeyDown(Keys.Enter))  select = true;
            if (currentKeyboardState.IsKeyDown(Keys.Up))     upArrow = true;
            if (currentKeyboardState.IsKeyDown(Keys.Down))   downArrow = true;
            if (currentKeyboardState.IsKeyDown(Keys.Left))   leftArrow = true;
            if (currentKeyboardState.IsKeyDown(Keys.Right))  rightArrow = true;

            // update mouse
            if (currentMouseState.LeftButton == ButtonState.Pressed) leftClick = ButtonState.Pressed;
            if (currentMouseState.LeftButton == ButtonState.Released) leftClick = ButtonState.Released;
            if (currentMouseState.RightButton == ButtonState.Pressed) rightClick = ButtonState.Pressed;
            if (currentMouseState.RightButton == ButtonState.Released) rightClick = ButtonState.Released;
            previousCursorPos = cursorPos;
            cursorPos.X = currentMouseState.X;
            cursorPos.Y = currentMouseState.Y;


            previousKeyboardState = currentKeyboardState;
            previousGamePadState = currentGamePadState;
            previousMouseState = currentMouseState;

            currentKeyboardState = Keyboard.GetState();
            currentGamePadState = GamePad.GetState(PlayerIndex.One);
            currentMouseState = Mouse.GetState();            
        }
    }
}
